Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 4130)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 4131)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Allow profile output for salsa variables.
+! 
+! 4039 2019-06-18 10:32:41Z suehring
 ! Correct conversion to kinematic scalar fluxes in case of pw-scheme and 
 ! statistic regions
@@ -335,5 +338,5 @@
                 simulated_time, simulated_time_at_begin,                       &
                 use_subsidence_tendencies, use_surface_fluxes, use_top_fluxes, &
-                ws_scheme_mom, ws_scheme_sca
+                ws_scheme_mom, ws_scheme_sca, salsa, max_pr_salsa
 
     USE cpulog,                                                                &
@@ -1954,4 +1957,12 @@
                 ENDIF
              ENDIF
+             IF ( salsa )  THEN
+                IF ( max_pr_cs > 0 )  THEN
+                   sums_l(:,pr_palm+max_pr_user+max_pr_cs+1:pr_palm+max_pr_user+max_pr_cs+max_pr_salsa,0) =    &
+                      sums_l(:,pr_palm+max_pr_user+max_pr_cs+1:pr_palm+max_pr_user+max_pr_cs+max_pr_salsa,0) + &
+                      sums_l(:,pr_palm+max_pr_user+max_pr_cs+1:pr_palm+max_pr_user+max_pr_cs+max_pr_salsa,i)
+
+                ENDIF
+             ENDIF
           ENDDO
        ENDIF
@@ -1974,4 +1985,13 @@
                 CALL MPI_ALLREDUCE( sums_l(nzb,pr_palm+max_pr_user+i,0),       &
                                     sums(nzb,pr_palm+max_pr_user+i),           &
+                                    nzt+2-nzb, MPI_REAL, MPI_SUM, comm2d, ierr )
+             ENDDO
+       ENDIF
+
+       IF ( salsa  .AND.  max_pr_salsa > 0 )  THEN
+          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+             DO  i = 1, max_pr_salsa
+                CALL MPI_ALLREDUCE( sums_l(nzb,pr_palm+max_pr_user+max_pr_cs+i,0),                 &
+                                    sums(nzb,pr_palm+max_pr_user+max_pr_user+i),                   &
                                     nzt+2-nzb, MPI_REAL, MPI_SUM, comm2d, ierr )
              ENDDO
@@ -2051,4 +2071,14 @@
                                  sums(k, pr_palm+1:pr_palm+max_pr_user+max_pr_cs) / &
                                  ngp_2dh_s_inner(k,sr)
+             ENDDO
+          ENDIF  
+       ENDIF
+
+       IF ( salsa ) THEN
+          IF ( max_pr_salsa > 0 )  THEN
+             DO k = nzb, nzt+1
+                sums(k,pr_palm+max_pr_user+max_pr_cs+1:pr_palm+max_pr_user+max_pr_cs+max_pr_salsa) = &
+                  sums(k,pr_palm+max_pr_user+max_pr_cs+1:pr_palm+max_pr_user+max_pr_cs+max_pr_salsa) &
+                  / ngp_2dh_s_inner(k,sr)
              ENDDO
           ENDIF  
@@ -2202,4 +2232,11 @@
           ENDIF
        ENDIF
+
+       IF ( salsa )  THEN
+          IF ( max_pr_salsa > 0 )  THEN    ! salsa profiles
+             hom(:,1,pr_palm+max_pr_user+max_pr_cs+1:pr_palm+max_pr_user+max_pr_cs+max_pr_salsa, sr) = &
+                  sums(:,pr_palm+max_pr_user+max_pr_cs+1:pr_palm+max_pr_user+max_pr_cs+max_pr_salsa)
+          ENDIF
+       ENDIF
 !
 !--    Determine the boundary layer height using two different schemes.
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 4130)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 4131)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Allocate sums and sums_l to allow profile output for salsa variables.
+! 
+! 4130 2019-08-01 13:04:13Z suehring
 ! Effectively reduce 3D initialization to 1D initial profiles. This is because
 ! 3D initialization produces structures in the w-component that are correlated
@@ -765,6 +768,6 @@
               ngp_2dh_s_inner_l(nzb:nzt+1,0:statistic_regions),                &
               rmask(nysg:nyng,nxlg:nxrg,0:statistic_regions),                  &
-              sums(nzb:nzt+1,pr_palm+max_pr_user+max_pr_cs),                   &
-              sums_l(nzb:nzt+1,pr_palm+max_pr_user+max_pr_cs,0:threads_per_task-1),      &
+              sums(nzb:nzt+1,pr_palm+max_pr_user+max_pr_cs+max_pr_salsa),      &
+              sums_l(nzb:nzt+1,pr_palm+max_pr_user+max_pr_cs+max_pr_salsa,0:threads_per_task-1),   &
               sums_l_l(nzb:nzt+1,0:statistic_regions,0:threads_per_task-1),    &
               sums_wsts_bc_l(nzb:nzt+1,0:statistic_regions) )
Index: palm/trunk/SOURCE/module_interface.f90
===================================================================
--- palm/trunk/SOURCE/module_interface.f90	(revision 4130)
+++ palm/trunk/SOURCE/module_interface.f90	(revision 4131)
@@ -397,4 +397,5 @@
         ONLY:  salsa_parin,                                                    &
                salsa_check_parameters,                                         &
+               salsa_check_data_output_pr,                                     &
                salsa_check_data_output,                                        &
                salsa_init_arrays,                                              &
@@ -409,4 +410,5 @@
                salsa_data_output_2d,                                           &
                salsa_data_output_3d,                                           &
+               salsa_statistics,                                               &
                salsa_rrd_local,                                                &
                salsa_wrd_local
@@ -783,4 +785,8 @@
     ENDIF
 
+    IF ( unit == 'illegal'  .AND.  salsa )  THEN
+       CALL salsa_check_data_output_pr( variable, var_count, unit, dopr_unit )
+    ENDIF
+
     IF ( unit == 'illegal'  .AND.  user_module_enabled )  THEN
        unit = '' ! ToDo: Seems like a hack. Find a general soultion!
@@ -1526,4 +1532,5 @@
     IF ( gust_module_enabled )  CALL gust_statistics( mode, sr, tn, dots_max )
     IF ( air_chemistry       )  CALL chem_statistics( mode, sr, tn )
+    IF ( salsa               )  CALL salsa_statistics( mode, sr, tn )
 
     IF ( user_module_enabled )  CALL user_statistics( mode, sr, tn )
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 4130)
+++ palm/trunk/SOURCE/modules.f90	(revision 4131)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Add max_pr_salsa to control_parameters. Used in creating profile output for
+! salsa.
+! 
+! 4110 2019-07-22 17:05:21Z suehring
 ! -advc_flags_1, advc_flags_2
 ! +advc_flags_m, advc_flags_s
@@ -1235,4 +1239,5 @@
     INTEGER(iwp) ::  maximum_grid_level                !< number of grid levels that the multigrid solver is using
     INTEGER(iwp) ::  maximum_parallel_io_streams = -1  !< maximum number of parallel io streams that the underlying parallel file system allows, set with palmrun option -w, ENVPAR namelist parameter, provided by palmrun
+    INTEGER(iwp) ::  max_pr_salsa = 0                  !< number of salsa profiles (must not change within a job chain)
     INTEGER(iwp) ::  max_pr_user = 0                   !< number of user-defined profiles (must not change within a job chain)
     INTEGER(iwp) ::  max_pr_user_tmp = 0               !< number of user-defined profiles that is temporary stored to check it against max_pr_user in case of restarts
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 4130)
+++ palm/trunk/SOURCE/parin.f90	(revision 4131)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Allocate hom and hom_sum to allow profile output for salsa variables.
+! 
+! 4079 2019-07-09 18:04:41Z suehring
 ! +monotonic_limiter_z
 ! 
@@ -1093,6 +1096,6 @@
                        ref_state(0:nz+1), sa_init(0:nz+1), ug(0:nz+1),         &
                        u_init(0:nz+1), v_init(0:nz+1), vg(0:nz+1),             &
-                       hom(0:nz+1,2,pr_palm+max_pr_user+max_pr_cs,0:statistic_regions),  &
-                       hom_sum(0:nz+1,pr_palm+max_pr_user+max_pr_cs,0:statistic_regions) )
+                    hom(0:nz+1,2,pr_palm+max_pr_user+max_pr_cs+max_pr_salsa,0:statistic_regions),  &
+                    hom_sum(0:nz+1,pr_palm+max_pr_user+max_pr_cs+max_pr_salsa,0:statistic_regions) )
 
              hom = 0.0_wp
Index: palm/trunk/SOURCE/read_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4130)
+++ palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4131)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Allocate hom and hom_sum to allow profile output for salsa variables.
+! 
+! 4101 2019-07-17 15:14:26Z gronemeier
 ! remove old_dt
 ! 
@@ -316,6 +319,6 @@
                     v_init(0:nz+1), pt_init(0:nz+1), q_init(0:nz+1),           &
                     ref_state(0:nz+1), s_init(0:nz+1), sa_init(0:nz+1),        &
-                    hom(0:nz+1,2,pr_palm+max_pr_user+max_pr_cs,0:statistic_regions),     &
-                    hom_sum(0:nz+1,pr_palm+max_pr_user+max_pr_cs,0:statistic_regions) )
+                    hom(0:nz+1,2,pr_palm+max_pr_user+max_pr_cs+max_pr_salsa,0:statistic_regions),  &
+                    hom_sum(0:nz+1,pr_palm+max_pr_user+max_pr_cs+max_pr_salsa,0:statistic_regions) )
        ENDIF
 
